#include <stdio.h>
/*        */
void	get ( fin, data, width, height, x, y, color, plane, colors, decimate_x, decimate_y, offset_x )
	FILE      *fin;
	char	data[];
	int	width, height, x, y, decimate_x, decimate_y;
	int	*color, colors[8];
	float *offset_x;
/* open and read an SIOSEIS plotfile, putting it in array data
*  SIOSEIS plot files start with 44 ASCII lines.  Line 1 is:
*  bytes 0-34 = SIOSEIS version number
*       35-58 = date the plot was created
*       68-71 = dots per inch.
*       72-75 = number of 32 bit words in every raster line
*       76-79 = number of raster lines
*
*  Paul Henkart,  Scripps Oceanography,  October 1994
*  (C) 1994, Regents of The University of California
*
*  mod 5 Feb 2001 - get grayscale flag from the first line of plot file.
*                   colors are 0-7 and grays are 8-15
*/


{
	static int nibs=0, bytes_per_line_sio, nbytes, rem_y;
     int       nwrds, i, j=0, k, kk, nlines, c_index=0;
	int		bits_per_line_x, bytes_per_line_x;
     char      sioseis_vers[36]= {" "},
               plot_date[32]= {" "}, line[81]= {" "},
			gray;
	unsigned char	nib;
	char		sio[2000], sio1[2000], sio2[2000];
	int		xbitno, xbyteno, bits_done, istat, nsio_done=0;
	long		address;


/*printf("bytes_per_line_x %d, width %d\n",bytes_per_line_x, width);*/
	if( !nibs ) {
		fread( &sioseis_vers, sizeof(char), 35, fin);
		fread( &plot_date, sizeof(char), 29, fin);
		fread( &line, sizeof(char), 16, fin);
		sscanf( line, "%c%d%d%d", &gray,&nibs,&nwrds,&nlines);
	printf("line:%s\n",line);
	printf("%c%d%d%d\n",gray,nibs, nwrds, nlines);
		if( strncmp(&gray,"g",1) == 0 ) c_index = 8;
	printf("c_index=%d\n",c_index);
		nbytes = nwrds * 4;
		bytes_per_line_sio = get_nbytes_sio( nibs );
          /* if there are 3 planes it must be a color plot!  */
		address = bytes_per_line_sio * nlines * 2;
          istat = fseek( fin, address, 0 );
		*color = fread( &sio, sizeof(char), 1, fin);
          *offset_x = *offset_x / 100. * (float)nlines;
		x = x + (long)*offset_x;
		rem_y = decimate_y - 1;
	}
	nsio_done = nsio_done + decimate_x - 1;
	bytes_per_line_x = width;
	if( *color != 1 ) bytes_per_line_x = width/8 + 1;
	if( plane != 0 ) address = address + (plane-1) *  bytes_per_line_sio * nlines;
	bits_per_line_x = bytes_per_line_x * 8;
	xbyteno = bytes_per_line_x-1;	/* byte number of the ximage */
	xbitno = 7;				/* bit number within the byte */
	for ( i=0; i<width; i++ ) {
		if( *color == 0 ) {
			address = 3520 + (x+nsio_done) * bytes_per_line_sio;
			istat = fseek( fin, address, 0 );
			istat = fread( &sio, sizeof(char), nbytes, fin);
			if( istat == 0 ) for( j=0; j<nbytes; j++ ) 
				sio[j] = 0;
			j = xbyteno;	/* byte within ximage of first raster */
			bits_done = 0;
			for ( k=y/8; k<nbytes; k++ ) {
				for ( kk=0; kk<8; kk++ ) {
					if( bits_done % decimate_y == rem_y ) {
						nib = ( sio[k] >> (7-kk) ) & 1;
						data[j] = data[j] | (nib<<(7-xbitno));
						j = j +  bytes_per_line_x;
					}
					bits_done++;
				}
				if( bits_done+2 > height * decimate_y ) k = bytes_per_line_sio;
			}
			xbitno--;
			if( xbitno < 0 ) { xbyteno--; xbitno = 7; }
		} else {
			address = 3520 + ((x+nsio_done) * bytes_per_line_sio) * 3;
			istat = fseek( fin, address, 0 );
			istat = fread( &sio, sizeof(char), nbytes, fin);
			address = address + bytes_per_line_sio;
			istat = fseek( fin, address, 0 );
			istat = fread(&sio1,sizeof(char),nbytes,fin);
			address = address + bytes_per_line_sio;
			istat = fseek( fin, address, 0 );
			istat = fread(&sio2,sizeof(char),nbytes,fin);
			if( istat == 0 ) for( j=0; j<bytes_per_line_sio; j++ ) 
				sio[j] = sio1[j] = sio2[j] = 0xff;
			j = xbyteno;	/* byte within ximage of first raster */
			bits_done = 0;
			for ( k=y/8; k<nbytes; k++ ) {
				for ( kk=0; kk<8; kk++ ) {
					if( bits_done % decimate_y == rem_y ) {
						data[j] = colors[c_index+((( sio[k] >> (7-kk) ) &1)
						 | ((( sio1[k] >> (7-kk) ) & 1) << 1 )
						 | ((( sio2[k] >> (7-kk) ) & 1) << 2 ))];
						j = j +  bytes_per_line_x;
					}
					bits_done++;
				}
				if( bits_done+2 > height * decimate_y ) k = bytes_per_line_sio;
			}
			xbyteno--;
		}
		nsio_done = nsio_done + decimate_x;
	}
	return;
}
